Loading...
Searching...
No Matches
Opm::FvBaseFdLocalLinearizer< TypeTag > Class Template Reference

Calculates the Jacobian of the local residual for finite volume spatial discretizations using a finite difference method. More...

`#include <fvbasefdlocallinearizer.hh>`

## Public Member Functions

| FvBaseFdLocalLinearizer (const FvBaseFdLocalLinearizer &)=delete
void | init (Simulator &simulator)
| Initialize the local Jacobian object.
void | linearize (const Element &element)
| Compute an element's local Jacobian matrix and evaluate its residual.
void | linearize (ElementContext &elemCtx, const Element &elem)
| Compute an element's local Jacobian matrix and evaluate its residual.
Scalar | numericEpsilon (const ElementContext &elemCtx, unsigned dofIdx, unsigned pvIdx) const
| Returns the epsilon value which is added and removed from the current solution.
LocalResidual & | localResidual ()
| Return reference to the local residual.
const LocalResidual & | localResidual () const
| Return reference to the local residual.
const ScalarMatrixBlock & | jacobian (unsigned domainScvIdx, unsigned rangeScvIdx) const
| Returns the local Jacobian matrix of the residual of a sub-control volume.
const ScalarVectorBlock & | residual (unsigned dofIdx) const
| Returns the local residual of a sub-control volume.

## Static Public Member Functions

static void | registerParameters ()
| Register all run-time parameters for the local jacobian.
static Scalar | baseEpsilon ()
| Returns the unweighted epsilon value used to calculate the local derivatives.

## Protected Member Functions

Implementation & | asImp_ ()
const Implementation & | asImp_ () const
const Simulator & | simulator_ () const
const Problem & | problem_ () const
const Model & | model_ () const
void | resize_ (const ElementContext &elemCtx)
| Resize all internal attributes to the size of the element.
void | reset_ (const ElementContext &elemCtx)
| Reset the all relevant internal attributes to 0.
void | evalPartialDerivative_ (ElementContext &elemCtx, unsigned dofIdx, unsigned pvIdx)
| Compute the partial derivatives of a context's residual functions.
void | updateLocalJacobian_ (const ElementContext &elemCtx, unsigned focusDofIdx, unsigned pvIdx)
| Updates the current local Jacobian matrix with the partial derivatives of all equations for primary variable 'pvIdx' at the degree of freedom associated with 'focusDofIdx'.

## Static Protected Member Functions

static int | numericDifferenceMethod_ ()
| Returns the numeric difference method which is applied.

## Protected Attributes

Simulator * | simulatorPtr_ {}
std::unique_ptr< ElementContext > | internalElemContext_ {}
LocalEvalBlockVector | residual_ {}
LocalEvalBlockVector | derivResidual_ {}
ScalarLocalBlockMatrix | jacobian_ {}
LocalResidual | localResidual_ {}

## Detailed Description

template<class TypeTag>
class Opm::FvBaseFdLocalLinearizer< TypeTag >

Calculates the Jacobian of the local residual for finite volume spatial discretizations using a finite difference method.

The local Jacobian for a given context is defined as the derivatives of the residuals of all degrees of freedom featured by the stencil with regard to the primary variables of the stencil's "primary" degrees of freedom.

This class implements numeric differentiation using finite difference methods, i.e. forward or backward differences (2nd order), or central differences (3rd order). The method used is determined by the "NumericDifferenceMethod" property:

- If the value of this property is smaller than 0, backward differences are used, i.e.:

- If the value of this property is 0, central differences are used, i.e.:

- if the value of this property is larger than 0, forward differences are used, i.e.:

Here, is the residual function for all equations, is the value of a sub-control volume's primary variable at the evaluation point and is a small scalar value larger than 0.

## Member Function Documentation

## evalPartialDerivative_()

template<class TypeTag>

void Opm::FvBaseFdLocalLinearizer< TypeTag >::evalPartialDerivative_ | ( | ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | pvIdx )

inline protected

Compute the partial derivatives of a context's residual functions.

This method can be overwritten by the implementation if a better scheme than numerical differentiation is available.

The default implementation of this method uses numeric differentiation, i.e. forward or backward differences (2nd order), or central differences (3rd order). The method used is determined by the "NumericDifferenceMethod" property:

- If the value of this property is smaller than 0, backward differences are used, i.e.:

- If the value of this property is 0, central differences are used, i.e.:

- if the value of this property is larger than 0, forward differences are used, i.e.:

Here, is the residual function for all equations, is the value of a sub-control volume's primary variable at the evaluation point and is a small value larger than 0.

Parameters

  elemCtx | The element context for which the local partial derivative ought to be calculated
  dofIdx | The sub-control volume index of the current finite element for which the partial derivative ought to be calculated
  pvIdx | The index of the primary variable at the dofIdx' sub-control volume of the current finite element for which the partial derivative ought to be calculated

## init()

template<class TypeTag>

void Opm::FvBaseFdLocalLinearizer< TypeTag >::init | ( | Simulator & | simulator | ) |

inline

Initialize the local Jacobian object.

At this point we can assume that everything has been allocated, although some objects may not yet be completely initialized.

Parameters

  simulator | The simulator object of the simulation.

## jacobian()

template<class TypeTag>

const ScalarMatrixBlock & Opm::FvBaseFdLocalLinearizer< TypeTag >::jacobian | ( | unsigned | domainScvIdx,
|  | unsigned | rangeScvIdx ) const

inline

Returns the local Jacobian matrix of the residual of a sub-control volume.

Parameters

  domainScvIdx | The local index of the sub control volume which contains the independents
  rangeScvIdx | The local index of the sub control volume which contains the local residual

## linearize() [1/2]

template<class TypeTag>

void Opm::FvBaseFdLocalLinearizer< TypeTag >::linearize | ( | const Element & | element | ) |

inline

Compute an element's local Jacobian matrix and evaluate its residual.

The local Jacobian for a given context is defined as the derivatives of the residuals of all degrees of freedom featured by the stencil with regard to the primary variables of the stencil's "primary" degrees of freedom. Adding the local Jacobians for all elements in the grid will give the global Jacobian 'grad f(x)'.

Parameters

  element | The grid element for which the local residual and its local Jacobian should be calculated.

## linearize() [2/2]

template<class TypeTag>

void Opm::FvBaseFdLocalLinearizer< TypeTag >::linearize | ( | ElementContext & | elemCtx,
|  | const Element & | elem )

inline

Compute an element's local Jacobian matrix and evaluate its residual.

The local Jacobian for a given context is defined as the derivatives of the residuals of all degrees of freedom featured by the stencil with regard to the primary variables of the stencil's "primary" degrees of freedom. Adding the local Jacobians for all elements in the grid will give the global Jacobian 'grad f(x)'.

After calling this method the ElementContext is in an undefined state, so do not use it anymore!

Parameters

  elemCtx | The element execution context for which the local residual and its local Jacobian should be calculated.
  elem | Element to linearize for

## numericEpsilon()

template<class TypeTag>

Scalar Opm::FvBaseFdLocalLinearizer< TypeTag >::numericEpsilon | ( | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | pvIdx ) const

inline

Returns the epsilon value which is added and removed from the current solution.

Parameters

  elemCtx | The element execution context for which the local residual and its gradient should be calculated.
  dofIdx | The local index of the element's vertex for which the local derivative ought to be calculated.
  pvIdx | The index of the primary variable which gets varied

## residual()

template<class TypeTag>

const ScalarVectorBlock & Opm::FvBaseFdLocalLinearizer< TypeTag >::residual | ( | unsigned | dofIdx | ) | const

inline

Returns the local residual of a sub-control volume.

Parameters

  dofIdx | The local index of the sub control volume

The documentation for this class was generated from the following file:

- opm/models/discretization/common/fvbasefdlocallinearizer.hh